// -*- Mode:C++ -*-
//Header:
//File: Config.h
//Title: Config Options
//Author: NODA, Itsuki
//Date: 2002/04/10
//

//ModifyHistory:
// 2001/03/02: Start to create this file
// 2002/04/10: Branch from chagama.cc
//EndModifyHistory:

#ifndef _Bun_Config_h_
#define _Bun_Config_h_
////////////////////////////////////////////////////////////////////////

#include "itk/itk.h"

#include <stl.h>
#include "SimplePlayer.h"
#include "OnlineCoach.h"
#include "OfflineCoach.h"

#include "Param.h"
#include "PlayPhase.h"

namespace Soccer {

#ifdef _INCLUDE_BODY_
# define __INIT_VAL__(form) = form
# define __EXTERN
#else
# define __INIT_VAL__(form)
# define __EXTERN extern
#endif

//======================================================================
// Option 

#define DFLT_TEAMNAME "bun"

   __EXTERN char * TeamName 	__INIT_VAL__(DFLT_TEAMNAME) ;
   __EXTERN char * ParamFile 	__INIT_VAL__(DFLT_TEAMNAME ".param") ;

   __EXTERN char * SHost 	__INIT_VAL__("localhost") ;
   __EXTERN Int SPort 		__INIT_VAL__(6000) ;
   __EXTERN Int OffCoachPort 	__INIT_VAL__(6001) ;
   __EXTERN Int CoachPort 	__INIT_VAL__(6002) ;

   __EXTERN Bool GoalieP 	__INIT_VAL__(False) ;

   __EXTERN Flt PlayerSpeedMax 	__INIT_VAL__(1.0) ;

   __EXTERN Int DebugLevel 	__INIT_VAL__(0) ;

   __EXTERN Bool TestP 		__INIT_VAL__(False) ;

   __EXTERN Flt Test2DashPower 	__INIT_VAL__(100) ;

   //------------------------------------------------------------
   // getopt

   __EXTERN void getopt(int & argc, char ** & argv) 
#ifdef _INCLUDE_BODY_
   {
      OptArg opt[] = {
	 {"shost",     OptArg::cstringVal, &SHost, 0,   "sserver_hostname"},
	 {"sport",     OptArg::IntVal,     &SPort, 0,   "sserver_portnum"},
	 {"goalie",    OptArg::OnOff,	&GoalieP,0,  "[on/off]"},
	 {"team",      OptArg::cstringVal, &TeamName,0, "teamname"},
	 {"param",     OptArg::cstringVal, &ParamFile,0, "parameter_filename"},
	 {"debug",     OptArg::IntVal,	&DebugLevel,0,  "debug_level [0-100]"},

	 {"test",      OptArg::OnOff,	&TestP,0,  "test flag [on/off]"},
	 {"test2",     OptArg::FltVal,	&Test2DashPower,0,  "power"},

	 {ITK_NULLPTR}} ;

      myGetOpt(opt,argc,argv) ;
      ITK_SET_VBS(DebugLevel) ;
   }
#endif
   ;
   
#undef __INIT_VAL__(form)
#undef __EXTERN

} ;
////////////////////////////////////////////////////////////////////////
#endif


