/*
 * Header    :
 * File      : PlayPhase.hxx
 * Auther    : Kosuke Shinoda
 * Since     : "2002-03-11 22:09:44 kshinoda"
 * Time-stamp: "2002-04-04 01:39:21 kshinoda"
 * Comment   :
 * End       :
 */
/*
 * Copyright (C) 2001,2002 SHINODA, Kosuke. Jaist,Japan & CARC, AIST, JAPAN
 * Copyright (C) 2001 NODA, Itsuki, CARC, AIST, JAPAN
 */

#ifndef __Chagama_PlayPhase_hxx__
#define __Chagama_PlayPhase_hxx__

#include "SimplePlayer.h"

using namespace Itk;
using namespace Soccer;

class PlayPhase : public WithDescriber {

   public:
      enum Type {
	 Nop,
	 Dango,
	 FixedPosition,
	 DeployToHome,
	 PP_Max,
      } ;
      static const char * tname(Type t) {
	 switch(t) {
	    case Nop :			return "nop" ;
	    case Dango : 		return "dango" ;
	    case FixedPosition : 	return "fixed_pos" ;
	    case DeployToHome : 	return "deploy_to_home" ;
	    default :			return "(none)" ;
	 }
      } ;

   public:
      CycleStep time ;
      Type type ;
      Flt _farg1 ;  Flt _farg2 ;  Flt _farg3 ;
      Int _iarg1 ;  Int _iarg2 ;  Int _iarg3 ;

      //--------------------------------------------------
      // access
   public:
      ITK_DEF_ACCESS(Flt & farg1(), { return _farg1 ; }); 
      ITK_DEF_ACCESS(Flt & farg2(), { return _farg2 ; }); 
      ITK_DEF_ACCESS(Flt & farg3(), { return _farg3 ; }); 
      ITK_DEF_ACCESS(Int & iarg1(), { return _iarg1 ; }); 
      ITK_DEF_ACCESS(Int & iarg2(), { return _iarg2 ; }); 
      ITK_DEF_ACCESS(Int & iarg3(), { return _iarg3 ; }); 
#if 0
      //--------------------------------------------------
      // describe
   public:
      virtual void describe(ostream & ostr, 
			    const BROADCASTool detailp = True) const {
	 ostr << "#PlayPhase[" << tname(type) << "]" ;

	 if(detailp) {
	    ostr << endl ;
	    ostr << "\t" "farg1=" << farg1() << endl ;
	    ostr << "\t" "farg2=" << farg2() << endl ;
	    ostr << "\t" "farg3=" << farg3() << endl ;

	    ostr << "\t" "iarg1=" << iarg1() << endl ;
	    ostr << "\t" "iarg2=" << iarg2() << endl ;
	    ostr << "\t" "iarg3=" << iarg3() << endl ;
	 } 
      } ;
#endif
} ;

//============================================================
// class: PlayPhaseStack
class PlayPhaseStack : public StackT<PlayPhase> { 
   public:
      MutexCondVar mtxcv ;
      
   public:
      virtual ~PlayPhaseStack() {} ;

   public:
      void lock() { return mtxcv.lock() ; } ;
      void unlock() { return mtxcv.unlock() ; } ;
      void signal() { return mtxcv.signal() ; } ;
      void broadcast() { return mtxcv.broadcast() ; } ;
      Int wait() { return mtxcv.wait() ; } ;
      Int lockWait() { return mtxcv.lockWait() ; } ;
} ;

#endif
